<h1>La liste des paires </h1>
<button class="mb-3" nz-button nzType="primary" [nzLoading]="loading">
  <i nz-icon nzType="search"></i>Pairs trouvés <span class="badge badge-light ml-3">{{pagination.total}}</span>
</button>
<button (click)="onResetPairs()" nz-popover class="mb-3 ml-5" nz-button nzType="danger"
        nzContent="Réinitialise toutes les moyennes des paires EN SERVICES ! Les données des paires éliminées ne seront pas reset">
  <i nz-icon nzType="retweet"></i>[Paires] Reset Moyennes
</button>

<button (click)="onResetSymbols()" nz-popover class="mb-3 ml-5" nz-button nzType="danger"
        nzContent="Réinitialise toutes les moyennes des symboles EN SERVICES ! Les données des symboles éliminés ne seront pas reset">
  <i nz-icon nzType="retweet"></i> [Symboles] Reset Moyennes
</button>

<div>
  <div class="mb-3">
    <app-filters-pairs (onUpdate)="onUpdate()" [(request)]="request"></app-filters-pairs>
    <br>
    <app-pagination
      (onUpdate)="onUpdate()"
      [total]="pagination.total"
      [(paginate)]="pagination.paginate"
      [(index)]="pagination.index"
    ></app-pagination>

    <br>
    <nz-spin nzSize="large" [nzSpinning]="loading">
      <router-outlet></router-outlet>
      <nz-table
        [nzWidthConfig]="['7%','15%','11%','16%','10%','8.5%','8.5%','9%','9%','7%']"
        nzBordered
        [nzData]="pagination.total"
        [nzFrontPagination]="false"
      >
        <thead>
        <tr>
          <th rowspan="4" class="position-relative" [nzChecked]="checked" [nzIndeterminate]="indeterminate" (nzCheckedChange)="onAllChecked($event)">
            <div *ngIf="arrChecked.length" style="color:dodgerblue ;position: absolute;top : 50%; left : 50% ;transform: translate(55%,-50%);" >{{setOfCheckedId.size}}</div>
          </th>
          <th  rowspan="4">Nom</th>
          <th rowspan="4">Status</th>
          <th colspan="5">Les moyennes pour <nz-tag nzColor="blue"><strong>{{isfor}}</strong></nz-tag> USD</th>
          <th  colSpan="2" >Markets </th>
          <th rowSpan="4" style="text-align: center;">
            <app-report-pairs (afterUpdate)="onGroupUpdate()" [pairs]="arrChecked" [selectMultiple]="true">
              <button nz-button nzType="danger" nzSize="small" ><i  nz-icon nzType="delete"></i></button>
            </app-report-pairs>
          </th>
        </tr>

        <tr>
          <th >Spread $ moyen</th>
          <th >Freq + vs -</th>
          <th >Freq best pair </th>
          <th >Freq no volume </th>
          <th >Freq erreur </th>
          <th > Est dans [M] </th>
          <th > Use dans [M]</th>
        </tr>

        </thead>

        <tbody>
        <tr *ngFor="let pair of pairs">
          <!--checkbox-->
          <td [nzChecked]="setOfCheckedId.has(pair.name)"
              (nzCheckedChange)="onItemChecked(pair.name, $event)">
          </td>
          <!--Nom-->
          <td class="btn-link" style="color: black; cursor: pointer"  (click)="navigate(pair.name)">{{pair.name}}</td>
          <!--Status-->
          <td>
            <nz-tag class="m-0" [nzColor]="colors[pair.exclusion.severity]">
              {{pair.exclusion.severity ? strSeverities[pair.exclusion.severity] : "en service"}}
            </nz-tag>
          </td>
          <!--Spread moyen-->
          <td *ngIf="pair.isfor[isfor].spreadMoyen_usd; else negativSpread">
            <button nz-button nzType="primary" nzGhost>{{pair.isfor[isfor].spreadMoyen_usd | exponentiel : 2}} $</button>
          </td>
          <ng-template #negativSpread><td><button nz-button nzSize="small" nzType="dashed">Pas de data</button></td></ng-template>

          <!--Freq + et -  -->
          <td>
            <nz-tag nzColor="green"> {{pair.isfor[isfor].positiveFreq }} </nz-tag>
            <nz-tag  class="m-0" nzColor="red"> {{pair.isfor[isfor].negativeFreq }} </nz-tag>
          </td>
          <!--freq best  -->
          <td>
            <nz-tag nzColor="blue">
              <strong>{{pair.isfor[isfor].isBestFreq}}</strong> /{{pair.isfor[isfor].positiveFreq + pair.isfor[isfor].negativeFreq + pair.isfor[isfor].errorFreq + pair.isfor[isfor].notEnoughtVolFreq}}
              <i class="iconeTab" *ngIf="pair.isfor[isfor].isBestFreq" nz-icon nzType="crown" nzTwotoneColor="orange" nzTheme="twotone"></i>
            </nz-tag>
          </td>
          <!--freq no volume-->
          <td >
            <span style="color: darkorange; ; font-weight: 500">{{pair.isfor[isfor].notEnoughtVolFreq}}</span>
            / {{pair.isfor[isfor].positiveFreq + pair.isfor[isfor].negativeFreq + pair.isfor[isfor].errorFreq + pair.isfor[isfor].notEnoughtVolFreq}}
          </td>

          <!--freq erreur-->
          <td>
            <span style="color: #ff6b6b; font-weight: 500">{{pair.isfor[isfor].errorFreq}}</span>
            /{{pair.isfor[isfor].positiveFreq + pair.isfor[isfor].negativeFreq + pair.isfor[isfor].errorFreq + pair.isfor[isfor].notEnoughtVolFreq}}
          </td>

          <!--nb markets-->
          <td>{{pair.marketsForThis}}</td>
          <!--nb market use-->
          <td>
            <strong [ngStyle]="{color : pair.marketsUsed > 1 ? '#0099ff' : 'red'}"> {{pair.marketsUsed}} </strong>
            <i class="iconeTab" *ngIf="pair.marketsUsed <= 1" nz-icon nzType="warning" nzTwotoneColor="red" nzTheme="twotone"></i>
          </td>
          <!--Delete-->
          <td style="text-align: center;">
            <app-report-pairs (afterUpdate)="onUpdate()" *ngIf="pair" [pairs]="[pair]" >
              <button nz-button nzType="danger" nzSize="small" nzShape="circle"><i  nz-icon nzType="delete"></i></button>
            </app-report-pairs>
          </td>

        </tr>
        </tbody>
      </nz-table>

    </nz-spin>
    <br>
    <app-pagination
      (onUpdate)="onUpdate()"
      [total]="pagination.total"
      [(paginate)]="pagination.paginate"
      [(index)]="pagination.index"
    ></app-pagination>
  </div>
</div>
